Index: trunk/IPs/systemC/processor/Morpheo/Files/Instance_scalar_1.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Files/Instance_scalar_1.cfg	(revision 100)
+++ 	(revision )
@@ -1,152 +1,0 @@
-<?xml version="1.0" encoding="ISO-8859-1" ?>
-
-<core name="Instance_scalar_1">
-
-  <thread id="0">             
-    <parameter name="size_ifetch_queue"                     value="4" />
-    <parameter name="nb_inst_fetch"                         value="1" />
-    <parameter name="ras_size_queue"                        value="2" />
-    <parameter name="upt_size_queue"                        value="2" />
-    <parameter name="ufpt_size_queue"                       value="2" />
-
-    <group id="0">
-      <parameter name="implement_group"                     value="1" />
-    </group>
-  </thread>                                                 
-                                                            
-  <decod_bloc id="0">                                       
-    <parameter name="size_decod_queue"                      value="2" />
-    <parameter name="nb_inst_decod"                         value="1" />
-    <parameter name="nb_context_select"                     value="1" />
-    <parameter name="context_select_priority"               value="1" />
-    <parameter name="context_select_load_balancing"         value="1" />
-  </decod_bloc>                                             
-                                                            
-  <rename_bloc id="0">                                      
-    <parameter name="nb_inst_insert"                        value="1" />
-    <parameter name="nb_inst_retire"                        value="1" />
-    <parameter name="rename_select_priority"                value="1" />
-    <parameter name="rename_select_load_balancing"          value="1" />
-    <parameter name="rename_select_nb_front_end_select"     value="1" />
-    <parameter name="nb_general_register"                   value="64"/>
-    <parameter name="nb_special_register"                   value="4" />
-    <parameter name="nb_reg_free"                           value="1" />
-    <parameter name="nb_rename_unit_bank"                   value="1" />
-    <parameter name="size_read_counter"                     value="1" />
-  </rename_bloc>                                            
-                                                            
-  <read_bloc id="0">                                        
-    <parameter name="size_read_queue"                       value="2" />
-    <parameter name="size_reservation_station"              value="2" />
-    <parameter name="nb_inst_retire_reservation_station"    value="1" />
-  </read_bloc>                                              
-                                                            
-  <write_bloc id="0">                                       
-    <parameter name="size_write_queue"                      value="2" />
-    <parameter name="size_execute_queue"                    value="2" />
-    <parameter name="nb_bypass_write"                       value="0" />
-  </write_bloc>                                             
-                                                            
-  <load_store_unit id="0">                                  
-    <parameter name="size_store_queue"                      value="2" />
-    <parameter name="size_load_queue"                       value="2" />
-    <parameter name="size_speculative_access_queue"         value="2" />
-    <parameter name="nb_port_check"                         value="1" />
-    <parameter name="speculative_load"                      value="2" />
-    <parameter name="nb_bypass_memory"                      value="0" />
-    <parameter name="nb_cache_port"                         value="1" />
-    <parameter name="nb_inst_memory"                        value="1" />
-  </load_store_unit>
-
-  <functionnal_unit id="0">
-    <parameter name="nb_inst_functionnal_unit" value="1" />
-
-    <timing type="0" latence="1" delay="1" />
-  </functionnal_unit>
-
-  <front_end id="0">        
-    <parameter name="nb_decod_unit"                         value="1" />
-    <parameter name="nb_inst_branch_predict"                value="1" />
-    <parameter name="nb_inst_branch_decod"                  value="1" />
-    <parameter name="nb_inst_branch_update"                 value="1" />
-    <parameter name="btb_size_queue"                        value="32"/>
-    <parameter name="btb_associativity"                     value="1" />
-    <parameter name="btb_size_counter"                      value="2" />
-    <parameter name="btb_victim_scheme"                     value="1" />
-    <parameter name="dir_predictor_scheme"                  value="1" />
-  </front_end>
-
-  <ooo_engine id="0">
-    <parameter name="nb_rename_unit"                        value="1" />
-    <parameter name="nb_inst_issue"                         value="1" />
-    <parameter name="nb_inst_reexecute"                     value="1" />
-    <parameter name="nb_inst_commit"                        value="1" />
-    <parameter name="nb_inst_branch_complete"               value="1" />
-    <parameter name="nb_rename_unit_select"                 value="1" />
-    <parameter name="nb_execute_loop_select"                value="1" />
-    <parameter name="size_re_order_buffer"                  value="16"/>
-    <parameter name="nb_re_order_buffer_bank"               value="1" />
-    <parameter name="commit_priority"                       value="1" />
-    <parameter name="commit_load_balancing"                 value="1" />
-    <parameter name="size_issue_queue"                      value="4" />
-    <parameter name="nb_issue_queue_bank"                   value="1" />
-    <parameter name="issue_priority"                        value="1" />
-    <parameter name="issue_load_balancing"                  value="1" />
-    <parameter name="size_reexecute_queue"                  value="2" />
-    <parameter name="reexecute_priority"                    value="1" />
-    <parameter name="reexecute_load_balancing"              value="1" />
-  </ooo_engine>
-
-  <execute_loop id="0">
-    <parameter name="nb_read_unit"                          value="1" />
-    <parameter name="nb_write_unit"                         value="1" />
-    <parameter name="nb_gpr_bank"                           value="1" />
-    <parameter name="nb_gpr_port_read_by_bank"              value="1" />
-    <parameter name="nb_gpr_port_write_by_bank"             value="1" />
-    <parameter name="nb_spr_bank"                           value="1" />
-    <parameter name="nb_spr_port_read_by_bank"              value="1" />
-    <parameter name="nb_spr_port_write_by_bank"             value="1" />
-    <parameter name="execution_unit_to_write_unit_priority" value="1" />
-    <parameter name="read_unit_to_execution_unit_priority"  value="1" />
-
-    <execute_unit id="1">
-      <link name="link_execute_unit_with_load_store_unit"   src="0"/>
-    </execute_unit>
-    <execute_unit id="0">
-      <link name="link_execute_unit_with_functionnal_unit"  src="0"/>
-    </execute_unit>
-
-  </execute_loop>
-
-  <parameter name="size_data"                               value="32" />
-                                                            
-  <parameter name="dispatch_priority"                       value="1" />
-  <parameter name="dispatch_load_balancing"                 value="1" />
-                                                            
-  <parameter name="nb_icache_port"                          value="1" />
-  <parameter name="icache_port_priority"                    value="1" />
-  <parameter name="icache_port_load_balancing"              value="1" />
-                                                            
-  <parameter name="nb_dcache_port"                          value="1" />
-  <parameter name="dcache_port_priority"                    value="1" />
-  <parameter name="dcache_port_load_balancing"              value="1" />
-
-  <link name="link_decod_unit_with_decod_bloc"         src="0"     dest="0.0" />
-  <link name="link_rename_unit_with_rename_bloc"       src="0"     dest="0.0" />
-  <link name="link_read_unit_with_read_bloc"           src="0"     dest="0.0" />
-  <link name="link_write_unit_with_write_bloc"         src="0"     dest="0.0" />
-  <link name="link_decod_bloc_with_thread"             src="0"     dest="0"   />
-  <link name="link_rename_bloc_with_front_end"         src="0"     dest="0"   />
-  <link name="link_load_store_unit_with_thread"        src="0"     dest="0"   />
-
-  <link name="link_icache_port_with_thread"            src="0"     dest="0"   />
-  <link name="link_dcache_port_with_load_store_unit"   src="0.0"   dest="0"   />
-
-  <link name="table_dispatch"                          src="0.0.0" dest="1"   />
-  <link name="link_read_bloc_and_load_store_unit"      src="0.0"   dest="1"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="0.0"   dest="1"   />
-  <link name="link_write_bloc_and_load_store_unit"     src="0.0"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="0.0"   dest="1"   />
-  <link name="link_thread_and_functionnal_unit"        src="0.0"   dest="1"   />
-
-</core>
Index: trunk/IPs/systemC/processor/Morpheo/Files/Instance_scalar_2.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Files/Instance_scalar_2.cfg	(revision 100)
+++ 	(revision )
@@ -1,152 +1,0 @@
-<?xml version="1.0" encoding="ISO-8859-1" ?>
-
-<core name="Instance_scalar_2">
-
-  <thread id="0">             
-    <parameter name="size_ifetch_queue"                     value="8" />
-    <parameter name="nb_inst_fetch"                         value="1" />
-    <parameter name="ras_size_queue"                        value="8" />
-    <parameter name="upt_size_queue"                        value="4" />
-    <parameter name="ufpt_size_queue"                       value="2" />
-
-    <group id="0">
-      <parameter name="implement_group"                     value="1" />
-    </group>
-  </thread>                                                 
-                                                            
-  <decod_bloc id="0">                                       
-    <parameter name="size_decod_queue"                      value="4" />
-    <parameter name="nb_inst_decod"                         value="1" />
-    <parameter name="nb_context_select"                     value="1" />
-    <parameter name="context_select_priority"               value="1" />
-    <parameter name="context_select_load_balancing"         value="1" />
-  </decod_bloc>                                             
-                                                            
-  <rename_bloc id="0">                                      
-    <parameter name="nb_inst_insert"                        value="1" />
-    <parameter name="nb_inst_retire"                        value="1" />
-    <parameter name="rename_select_priority"                value="1" />
-    <parameter name="rename_select_load_balancing"          value="1" />
-    <parameter name="rename_select_nb_front_end_select"     value="1" />
-    <parameter name="nb_general_register"                   value="64"/>
-    <parameter name="nb_special_register"                   value="4" />
-    <parameter name="nb_reg_free"                           value="1" />
-    <parameter name="nb_rename_unit_bank"                   value="1" />
-    <parameter name="size_read_counter"                     value="1" />
-  </rename_bloc>                                            
-                                                            
-  <read_bloc id="0">                                        
-    <parameter name="size_read_queue"                       value="4" />
-    <parameter name="size_reservation_station"              value="4" />
-    <parameter name="nb_inst_retire_reservation_station"    value="1" />
-  </read_bloc>                                              
-                                                            
-  <write_bloc id="0">                                       
-    <parameter name="size_write_queue"                      value="4" />
-    <parameter name="size_execute_queue"                    value="4" />
-    <parameter name="nb_bypass_write"                       value="0" />
-  </write_bloc>                                             
-                                                            
-  <load_store_unit id="0">                                  
-    <parameter name="size_store_queue"                      value="4" />
-    <parameter name="size_load_queue"                       value="4" />
-    <parameter name="size_speculative_access_queue"         value="4" />
-    <parameter name="nb_port_check"                         value="1" />
-    <parameter name="speculative_load"                      value="2" />
-    <parameter name="nb_bypass_memory"                      value="0" />
-    <parameter name="nb_cache_port"                         value="1" />
-    <parameter name="nb_inst_memory"                        value="1" />
-  </load_store_unit>
-
-  <functionnal_unit id="0">
-    <parameter name="nb_inst_functionnal_unit" value="1" />
-
-    <timing type="0" latence="1" delay="1" />
-  </functionnal_unit>
-
-  <front_end id="0">        
-    <parameter name="nb_decod_unit"                         value="1" />
-    <parameter name="nb_inst_branch_predict"                value="1" />
-    <parameter name="nb_inst_branch_decod"                  value="1" />
-    <parameter name="nb_inst_branch_update"                 value="1" />
-    <parameter name="btb_size_queue"                        value="32"/>
-    <parameter name="btb_associativity"                     value="1" />
-    <parameter name="btb_size_counter"                      value="2" />
-    <parameter name="btb_victim_scheme"                     value="3" />
-    <parameter name="dir_predictor_scheme"                  value="1" />
-  </front_end>
-
-  <ooo_engine id="0">
-    <parameter name="nb_rename_unit"                        value="1" />
-    <parameter name="nb_inst_issue"                         value="1" />
-    <parameter name="nb_inst_reexecute"                     value="1" />
-    <parameter name="nb_inst_commit"                        value="1" />
-    <parameter name="nb_inst_branch_complete"               value="1" />
-    <parameter name="nb_rename_unit_select"                 value="1" />
-    <parameter name="nb_execute_loop_select"                value="1" />
-    <parameter name="size_re_order_buffer"                  value="32"/>
-    <parameter name="nb_re_order_buffer_bank"               value="2" />
-    <parameter name="commit_priority"                       value="1" />
-    <parameter name="commit_load_balancing"                 value="1" />
-    <parameter name="size_issue_queue"                      value="8" />
-    <parameter name="nb_issue_queue_bank"                   value="2" />
-    <parameter name="issue_priority"                        value="1" />
-    <parameter name="issue_load_balancing"                  value="1" />
-    <parameter name="size_reexecute_queue"                  value="4" />
-    <parameter name="reexecute_priority"                    value="1" />
-    <parameter name="reexecute_load_balancing"              value="1" />
-  </ooo_engine>
-
-  <execute_loop id="0">
-    <parameter name="nb_read_unit"                          value="1" />
-    <parameter name="nb_write_unit"                         value="1" />
-    <parameter name="nb_gpr_bank"                           value="2" />
-    <parameter name="nb_gpr_port_read_by_bank"              value="1" />
-    <parameter name="nb_gpr_port_write_by_bank"             value="1" />
-    <parameter name="nb_spr_bank"                           value="2" />
-    <parameter name="nb_spr_port_read_by_bank"              value="1" />
-    <parameter name="nb_spr_port_write_by_bank"             value="1" />
-    <parameter name="execution_unit_to_write_unit_priority" value="1" />
-    <parameter name="read_unit_to_execution_unit_priority"  value="1" />
-
-    <execute_unit id="1">
-      <link name="link_execute_unit_with_load_store_unit"   src="0"/>
-    </execute_unit>
-    <execute_unit id="0">
-      <link name="link_execute_unit_with_functionnal_unit"  src="0"/>
-    </execute_unit>
-
-  </execute_loop>
-
-  <parameter name="size_data"                               value="32" />
-                                                            
-  <parameter name="dispatch_priority"                       value="1" />
-  <parameter name="dispatch_load_balancing"                 value="1" />
-                                                            
-  <parameter name="nb_icache_port"                          value="1" />
-  <parameter name="icache_port_priority"                    value="1" />
-  <parameter name="icache_port_load_balancing"              value="1" />
-                                                            
-  <parameter name="nb_dcache_port"                          value="1" />
-  <parameter name="dcache_port_priority"                    value="1" />
-  <parameter name="dcache_port_load_balancing"              value="1" />
-
-  <link name="link_decod_unit_with_decod_bloc"         src="0"     dest="0.0" />
-  <link name="link_rename_unit_with_rename_bloc"       src="0"     dest="0.0" />
-  <link name="link_read_unit_with_read_bloc"           src="0"     dest="0.0" />
-  <link name="link_write_unit_with_write_bloc"         src="0"     dest="0.0" />
-  <link name="link_decod_bloc_with_thread"             src="0"     dest="0"   />
-  <link name="link_rename_bloc_with_front_end"         src="0"     dest="0"   />
-  <link name="link_load_store_unit_with_thread"        src="0"     dest="0"   />
-
-  <link name="link_icache_port_with_thread"            src="0"     dest="0"   />
-  <link name="link_dcache_port_with_load_store_unit"   src="0.0"   dest="0"   />
-
-  <link name="table_dispatch"                          src="0.0.0" dest="1"   />
-  <link name="link_read_bloc_and_load_store_unit"      src="0.0"   dest="1"   />
-  <link name="link_read_bloc_and_functionnal_unit"     src="0.0"   dest="1"   />
-  <link name="link_write_bloc_and_load_store_unit"     src="0.0"   dest="1"   />
-  <link name="link_write_bloc_and_functionnal_unit"    src="0.0"   dest="1"   />
-  <link name="link_thread_and_functionnal_unit"        src="0.0"   dest="1"   />
-
-</core>
Index: trunk/IPs/systemC/processor/Morpheo/Files/Instance_w1_1.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Files/Instance_w1_1.cfg	(revision 101)
+++ trunk/IPs/systemC/processor/Morpheo/Files/Instance_w1_1.cfg	(revision 101)
@@ -0,0 +1,152 @@
+<?xml version="1.0" encoding="ISO-8859-1" ?>
+
+<core name="Instance_scalar_1">
+
+  <thread id="0">             
+    <parameter name="size_ifetch_queue"                     value="4" />
+    <parameter name="nb_inst_fetch"                         value="1" />
+    <parameter name="ras_size_queue"                        value="2" />
+    <parameter name="upt_size_queue"                        value="2" />
+    <parameter name="ufpt_size_queue"                       value="2" />
+
+    <group id="0">
+      <parameter name="implement_group"                     value="1" />
+    </group>
+  </thread>                                                 
+                                                            
+  <decod_bloc id="0">                                       
+    <parameter name="size_decod_queue"                      value="2" />
+    <parameter name="nb_inst_decod"                         value="1" />
+    <parameter name="nb_context_select"                     value="1" />
+    <parameter name="context_select_priority"               value="1" />
+    <parameter name="context_select_load_balancing"         value="1" />
+  </decod_bloc>                                             
+                                                            
+  <rename_bloc id="0">                                      
+    <parameter name="nb_inst_insert"                        value="1" />
+    <parameter name="nb_inst_retire"                        value="1" />
+    <parameter name="rename_select_priority"                value="1" />
+    <parameter name="rename_select_load_balancing"          value="1" />
+    <parameter name="rename_select_nb_front_end_select"     value="1" />
+    <parameter name="nb_general_register"                   value="64"/>
+    <parameter name="nb_special_register"                   value="4" />
+    <parameter name="nb_reg_free"                           value="1" />
+    <parameter name="nb_rename_unit_bank"                   value="1" />
+    <parameter name="size_read_counter"                     value="1" />
+  </rename_bloc>                                            
+                                                            
+  <read_bloc id="0">                                        
+    <parameter name="size_read_queue"                       value="2" />
+    <parameter name="size_reservation_station"              value="2" />
+    <parameter name="nb_inst_retire_reservation_station"    value="1" />
+  </read_bloc>                                              
+                                                            
+  <write_bloc id="0">                                       
+    <parameter name="size_write_queue"                      value="2" />
+    <parameter name="size_execute_queue"                    value="2" />
+    <parameter name="nb_bypass_write"                       value="0" />
+  </write_bloc>                                             
+                                                            
+  <load_store_unit id="0">                                  
+    <parameter name="size_store_queue"                      value="2" />
+    <parameter name="size_load_queue"                       value="2" />
+    <parameter name="size_speculative_access_queue"         value="2" />
+    <parameter name="nb_port_check"                         value="1" />
+    <parameter name="speculative_load"                      value="2" />
+    <parameter name="nb_bypass_memory"                      value="0" />
+    <parameter name="nb_cache_port"                         value="1" />
+    <parameter name="nb_inst_memory"                        value="1" />
+  </load_store_unit>
+
+  <functionnal_unit id="0">
+    <parameter name="nb_inst_functionnal_unit" value="1" />
+
+    <timing type="0" latence="1" delay="1" />
+  </functionnal_unit>
+
+  <front_end id="0">        
+    <parameter name="nb_decod_unit"                         value="1" />
+    <parameter name="nb_inst_branch_predict"                value="1" />
+    <parameter name="nb_inst_branch_decod"                  value="1" />
+    <parameter name="nb_inst_branch_update"                 value="1" />
+    <parameter name="btb_size_queue"                        value="32"/>
+    <parameter name="btb_associativity"                     value="1" />
+    <parameter name="btb_size_counter"                      value="2" />
+    <parameter name="btb_victim_scheme"                     value="1" />
+    <parameter name="dir_predictor_scheme"                  value="1" />
+  </front_end>
+
+  <ooo_engine id="0">
+    <parameter name="nb_rename_unit"                        value="1" />
+    <parameter name="nb_inst_issue"                         value="1" />
+    <parameter name="nb_inst_reexecute"                     value="1" />
+    <parameter name="nb_inst_commit"                        value="1" />
+    <parameter name="nb_inst_branch_complete"               value="1" />
+    <parameter name="nb_rename_unit_select"                 value="1" />
+    <parameter name="nb_execute_loop_select"                value="1" />
+    <parameter name="size_re_order_buffer"                  value="16"/>
+    <parameter name="nb_re_order_buffer_bank"               value="1" />
+    <parameter name="commit_priority"                       value="1" />
+    <parameter name="commit_load_balancing"                 value="1" />
+    <parameter name="size_issue_queue"                      value="4" />
+    <parameter name="nb_issue_queue_bank"                   value="1" />
+    <parameter name="issue_priority"                        value="1" />
+    <parameter name="issue_load_balancing"                  value="1" />
+    <parameter name="size_reexecute_queue"                  value="2" />
+    <parameter name="reexecute_priority"                    value="1" />
+    <parameter name="reexecute_load_balancing"              value="1" />
+  </ooo_engine>
+
+  <execute_loop id="0">
+    <parameter name="nb_read_unit"                          value="1" />
+    <parameter name="nb_write_unit"                         value="1" />
+    <parameter name="nb_gpr_bank"                           value="1" />
+    <parameter name="nb_gpr_port_read_by_bank"              value="1" />
+    <parameter name="nb_gpr_port_write_by_bank"             value="1" />
+    <parameter name="nb_spr_bank"                           value="1" />
+    <parameter name="nb_spr_port_read_by_bank"              value="1" />
+    <parameter name="nb_spr_port_write_by_bank"             value="1" />
+    <parameter name="execution_unit_to_write_unit_priority" value="1" />
+    <parameter name="read_unit_to_execution_unit_priority"  value="1" />
+
+    <execute_unit id="1">
+      <link name="link_execute_unit_with_load_store_unit"   src="0"/>
+    </execute_unit>
+    <execute_unit id="0">
+      <link name="link_execute_unit_with_functionnal_unit"  src="0"/>
+    </execute_unit>
+
+  </execute_loop>
+
+  <parameter name="size_data"                               value="32" />
+                                                            
+  <parameter name="dispatch_priority"                       value="1" />
+  <parameter name="dispatch_load_balancing"                 value="1" />
+                                                            
+  <parameter name="nb_icache_port"                          value="1" />
+  <parameter name="icache_port_priority"                    value="1" />
+  <parameter name="icache_port_load_balancing"              value="1" />
+                                                            
+  <parameter name="nb_dcache_port"                          value="1" />
+  <parameter name="dcache_port_priority"                    value="1" />
+  <parameter name="dcache_port_load_balancing"              value="1" />
+
+  <link name="link_decod_unit_with_decod_bloc"         src="0"     dest="0.0" />
+  <link name="link_rename_unit_with_rename_bloc"       src="0"     dest="0.0" />
+  <link name="link_read_unit_with_read_bloc"           src="0"     dest="0.0" />
+  <link name="link_write_unit_with_write_bloc"         src="0"     dest="0.0" />
+  <link name="link_decod_bloc_with_thread"             src="0"     dest="0"   />
+  <link name="link_rename_bloc_with_front_end"         src="0"     dest="0"   />
+  <link name="link_load_store_unit_with_thread"        src="0"     dest="0"   />
+
+  <link name="link_icache_port_with_thread"            src="0"     dest="0"   />
+  <link name="link_dcache_port_with_load_store_unit"   src="0.0"   dest="0"   />
+
+  <link name="table_dispatch"                          src="0.0.0" dest="1"   />
+  <link name="link_read_bloc_and_load_store_unit"      src="0.0"   dest="1"   />
+  <link name="link_read_bloc_and_functionnal_unit"     src="0.0"   dest="1"   />
+  <link name="link_write_bloc_and_load_store_unit"     src="0.0"   dest="1"   />
+  <link name="link_write_bloc_and_functionnal_unit"    src="0.0"   dest="1"   />
+  <link name="link_thread_and_functionnal_unit"        src="0.0"   dest="1"   />
+
+</core>
Index: trunk/IPs/systemC/processor/Morpheo/Files/Instance_w1_2.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Files/Instance_w1_2.cfg	(revision 101)
+++ trunk/IPs/systemC/processor/Morpheo/Files/Instance_w1_2.cfg	(revision 101)
@@ -0,0 +1,152 @@
+<?xml version="1.0" encoding="ISO-8859-1" ?>
+
+<core name="Instance_scalar_2">
+
+  <thread id="0">             
+    <parameter name="size_ifetch_queue"                     value="8" />
+    <parameter name="nb_inst_fetch"                         value="1" />
+    <parameter name="ras_size_queue"                        value="8" />
+    <parameter name="upt_size_queue"                        value="4" />
+    <parameter name="ufpt_size_queue"                       value="2" />
+
+    <group id="0">
+      <parameter name="implement_group"                     value="1" />
+    </group>
+  </thread>                                                 
+                                                            
+  <decod_bloc id="0">                                       
+    <parameter name="size_decod_queue"                      value="4" />
+    <parameter name="nb_inst_decod"                         value="1" />
+    <parameter name="nb_context_select"                     value="1" />
+    <parameter name="context_select_priority"               value="1" />
+    <parameter name="context_select_load_balancing"         value="1" />
+  </decod_bloc>                                             
+                                                            
+  <rename_bloc id="0">                                      
+    <parameter name="nb_inst_insert"                        value="1" />
+    <parameter name="nb_inst_retire"                        value="1" />
+    <parameter name="rename_select_priority"                value="1" />
+    <parameter name="rename_select_load_balancing"          value="1" />
+    <parameter name="rename_select_nb_front_end_select"     value="1" />
+    <parameter name="nb_general_register"                   value="64"/>
+    <parameter name="nb_special_register"                   value="4" />
+    <parameter name="nb_reg_free"                           value="1" />
+    <parameter name="nb_rename_unit_bank"                   value="1" />
+    <parameter name="size_read_counter"                     value="1" />
+  </rename_bloc>                                            
+                                                            
+  <read_bloc id="0">                                        
+    <parameter name="size_read_queue"                       value="4" />
+    <parameter name="size_reservation_station"              value="4" />
+    <parameter name="nb_inst_retire_reservation_station"    value="1" />
+  </read_bloc>                                              
+                                                            
+  <write_bloc id="0">                                       
+    <parameter name="size_write_queue"                      value="4" />
+    <parameter name="size_execute_queue"                    value="4" />
+    <parameter name="nb_bypass_write"                       value="0" />
+  </write_bloc>                                             
+                                                            
+  <load_store_unit id="0">                                  
+    <parameter name="size_store_queue"                      value="4" />
+    <parameter name="size_load_queue"                       value="4" />
+    <parameter name="size_speculative_access_queue"         value="4" />
+    <parameter name="nb_port_check"                         value="1" />
+    <parameter name="speculative_load"                      value="2" />
+    <parameter name="nb_bypass_memory"                      value="0" />
+    <parameter name="nb_cache_port"                         value="1" />
+    <parameter name="nb_inst_memory"                        value="1" />
+  </load_store_unit>
+
+  <functionnal_unit id="0">
+    <parameter name="nb_inst_functionnal_unit" value="1" />
+
+    <timing type="0" latence="1" delay="1" />
+  </functionnal_unit>
+
+  <front_end id="0">        
+    <parameter name="nb_decod_unit"                         value="1" />
+    <parameter name="nb_inst_branch_predict"                value="1" />
+    <parameter name="nb_inst_branch_decod"                  value="1" />
+    <parameter name="nb_inst_branch_update"                 value="1" />
+    <parameter name="btb_size_queue"                        value="32"/>
+    <parameter name="btb_associativity"                     value="1" />
+    <parameter name="btb_size_counter"                      value="2" />
+    <parameter name="btb_victim_scheme"                     value="3" />
+    <parameter name="dir_predictor_scheme"                  value="1" />
+  </front_end>
+
+  <ooo_engine id="0">
+    <parameter name="nb_rename_unit"                        value="1" />
+    <parameter name="nb_inst_issue"                         value="1" />
+    <parameter name="nb_inst_reexecute"                     value="1" />
+    <parameter name="nb_inst_commit"                        value="1" />
+    <parameter name="nb_inst_branch_complete"               value="1" />
+    <parameter name="nb_rename_unit_select"                 value="1" />
+    <parameter name="nb_execute_loop_select"                value="1" />
+    <parameter name="size_re_order_buffer"                  value="32"/>
+    <parameter name="nb_re_order_buffer_bank"               value="2" />
+    <parameter name="commit_priority"                       value="1" />
+    <parameter name="commit_load_balancing"                 value="1" />
+    <parameter name="size_issue_queue"                      value="8" />
+    <parameter name="nb_issue_queue_bank"                   value="2" />
+    <parameter name="issue_priority"                        value="1" />
+    <parameter name="issue_load_balancing"                  value="1" />
+    <parameter name="size_reexecute_queue"                  value="4" />
+    <parameter name="reexecute_priority"                    value="1" />
+    <parameter name="reexecute_load_balancing"              value="1" />
+  </ooo_engine>
+
+  <execute_loop id="0">
+    <parameter name="nb_read_unit"                          value="1" />
+    <parameter name="nb_write_unit"                         value="1" />
+    <parameter name="nb_gpr_bank"                           value="2" />
+    <parameter name="nb_gpr_port_read_by_bank"              value="1" />
+    <parameter name="nb_gpr_port_write_by_bank"             value="1" />
+    <parameter name="nb_spr_bank"                           value="2" />
+    <parameter name="nb_spr_port_read_by_bank"              value="1" />
+    <parameter name="nb_spr_port_write_by_bank"             value="1" />
+    <parameter name="execution_unit_to_write_unit_priority" value="1" />
+    <parameter name="read_unit_to_execution_unit_priority"  value="1" />
+
+    <execute_unit id="1">
+      <link name="link_execute_unit_with_load_store_unit"   src="0"/>
+    </execute_unit>
+    <execute_unit id="0">
+      <link name="link_execute_unit_with_functionnal_unit"  src="0"/>
+    </execute_unit>
+
+  </execute_loop>
+
+  <parameter name="size_data"                               value="32" />
+                                                            
+  <parameter name="dispatch_priority"                       value="1" />
+  <parameter name="dispatch_load_balancing"                 value="1" />
+                                                            
+  <parameter name="nb_icache_port"                          value="1" />
+  <parameter name="icache_port_priority"                    value="1" />
+  <parameter name="icache_port_load_balancing"              value="1" />
+                                                            
+  <parameter name="nb_dcache_port"                          value="1" />
+  <parameter name="dcache_port_priority"                    value="1" />
+  <parameter name="dcache_port_load_balancing"              value="1" />
+
+  <link name="link_decod_unit_with_decod_bloc"         src="0"     dest="0.0" />
+  <link name="link_rename_unit_with_rename_bloc"       src="0"     dest="0.0" />
+  <link name="link_read_unit_with_read_bloc"           src="0"     dest="0.0" />
+  <link name="link_write_unit_with_write_bloc"         src="0"     dest="0.0" />
+  <link name="link_decod_bloc_with_thread"             src="0"     dest="0"   />
+  <link name="link_rename_bloc_with_front_end"         src="0"     dest="0"   />
+  <link name="link_load_store_unit_with_thread"        src="0"     dest="0"   />
+
+  <link name="link_icache_port_with_thread"            src="0"     dest="0"   />
+  <link name="link_dcache_port_with_load_store_unit"   src="0.0"   dest="0"   />
+
+  <link name="table_dispatch"                          src="0.0.0" dest="1"   />
+  <link name="link_read_bloc_and_load_store_unit"      src="0.0"   dest="1"   />
+  <link name="link_read_bloc_and_functionnal_unit"     src="0.0"   dest="1"   />
+  <link name="link_write_bloc_and_load_store_unit"     src="0.0"   dest="1"   />
+  <link name="link_write_bloc_and_functionnal_unit"    src="0.0"   dest="1"   />
+  <link name="link_thread_and_functionnal_unit"        src="0.0"   dest="1"   />
+
+</core>
Index: trunk/IPs/systemC/processor/Morpheo/Files/Morpheo.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Files/Morpheo.gen	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Files/Morpheo.gen	(revision 101)
@@ -73,6 +73,6 @@
   <parameter name="btb_associativity"                     min="1"   max="8"    step="* 2" default="1"   level="..." description="..." />
   <parameter name="btb_size_counter"                      min="2"   max="8"    step="* 2" default="2"   level="..." description="..." />
-  <parameter name="btb_victim_scheme"                     min="1"   max="8"    step="+ 1" default="1"   level="..." description="..." />
-  <parameter name="dir_predictor_scheme"                  min="1"   max="8"    step="* 2" default="1"   level="..." description="..." />
+  <parameter name="btb_victim_scheme"                     min="0"   max="5"    step="+ 1" default="1"   level="..." description="0 : Random, 1 : Round Robin, 2 : Not Last Used, 3 : Pseudo LRU, 4 : Least Recently Used, 5 : FIFO" />
+  <parameter name="dir_predictor_scheme"                  min="0"   max="8"    step="+ 1" default="1"   level="..." description="0 : Never take, 1 : Always Take, 2 : Static, 3 : Last Take, 4 : Counter, 5 : Local predictor, 6 : Global predictor, 7 : Meta predictor, 8 : Custom predictor" />
   <parameter name="dir_have_bht"                          min="1"   max="8"    step="* 2" default="1"   level="..." description="..." />
   <parameter name="dir_bht_size_shifter"                  min="1"   max="8"    step="* 2" default="1"   level="..." description="..." />
Index: trunk/IPs/systemC/processor/Morpheo/Files/Morpheo.sim
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Files/Morpheo.sim	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Files/Morpheo.sim	(revision 101)
@@ -15,5 +15,5 @@
   <parameter name="statistics_period"          value="0" />
                                                
-  <parameter name="simulation_nb_cycle"        value="10000" />
+  <parameter name="simulation_nb_cycle"        value="100" />
   <parameter name="simulation_nb_instruction"  value="0"   />
 
@@ -23,7 +23,7 @@
   <parameter name="directory_log"              value="." />
 
-  <parameter name="debug_level"                value="0" />
+  <parameter name="debug_level"                value="3" />
   <parameter name="debug_cycle_start"          value="0" />
-  <parameter name="debug_cycle_stop"           value="400" />
+  <parameter name="debug_cycle_stop"           value="300" />
   <parameter name="debug_have_log_file"        value="0" />
 