Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 104)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 106)
@@ -18,4 +18,211 @@
 namespace load_store_unit {
 
+template <typename T>
+T swapBytes (T data, uint32_t size_data, uint32_t size_access)
+{
+  uint64_t x = static_cast<uint64_t>(data);
+
+//   switch (size_data)
+//     {
+//     case 2 : // 16 bits
+//       {
+//         switch (size_access)
+//           {
+//           case 2 : 
+//             {
+//               x = ((((x>> 8)&0xff) <<  0) |
+//                    (((x>> 0)&0xff) <<  8) );
+//               break;
+//             }
+//           default :
+//             {
+//               break;
+//             }
+//           }
+//         break;
+//       }
+//     case 4 : // 32 bits
+//       {
+//         switch (size_access)
+//           {
+//           case 2 : 
+//             {
+//               x = ((((x>> 8)&0xff) <<  0) |
+//                    (((x>> 0)&0xff) <<  8) |
+//                    (((x>>24)&0xff) << 16) |
+//                    (((x>>16)&0xff) << 24) );
+//               break;
+//             }
+//           case 4 : 
+//             {
+//               x = ((((x>>24)&0xff) <<  0) |
+//                    (((x>>16)&0xff) <<  8) |
+//                    (((x>> 8)&0xff) << 16) |
+//                    (((x>> 0)&0xff) << 24) );
+//               break;
+//             }
+//           default :
+//             {
+//               break;
+//             }
+//           }
+//         break;
+//       }
+//     case 8 : // 64 bits
+//       {
+//         switch (size_access)
+//           {
+//           case 2 : 
+//             {
+//               x = ((((x>> 8)&0xff) <<  0) |
+//                    (((x>> 0)&0xff) <<  8) |
+//                    (((x>>24)&0xff) << 16) |
+//                    (((x>>16)&0xff) << 24) |
+//                    (((x>>40)&0xff) << 32) |
+//                    (((x>>32)&0xff) << 40) |
+//                    (((x>>56)&0xff) << 48) |
+//                    (((x>>48)&0xff) << 56) );
+//               break;
+//             }
+//           case 4 : 
+//             {
+//               x = ((((x>>24)&0xff) <<  0) |
+//                    (((x>>16)&0xff) <<  8) |
+//                    (((x>> 8)&0xff) << 16) |
+//                    (((x>> 0)&0xff) << 24) |
+//                    (((x>>56)&0xff) << 32) |
+//                    (((x>>48)&0xff) << 40) |
+//                    (((x>>40)&0xff) << 48) |
+//                    (((x>>32)&0xff) << 56) );
+//               break;
+//             }
+//           case 8 : 
+//             {
+//               x = ((((x>>56)&0xff) <<  0) |
+//                    (((x>>48)&0xff) <<  8) |
+//                    (((x>>40)&0xff) << 16) |
+//                    (((x>>32)&0xff) << 24) |
+//                    (((x>>24)&0xff) << 32) |
+//                    (((x>>16)&0xff) << 40) |
+//                    (((x>> 8)&0xff) << 48) |
+//                    (((x>> 0)&0xff) << 56) );
+//               break;
+//             }
+//           default :
+//             {
+//               break;
+//             }
+//           }
+//         break;
+//       }
+//     default :
+//       {
+//         break;
+//       }
+//     }
+
+
+  uint64_t y=0;
+
+  for (uint32_t i=0; i<size_data; i+=size_access)
+    {
+      uint32_t offset = i<<3;
+
+      switch (size_access)
+        {
+        case 1 :
+          {
+            y = x;
+            break;
+          }
+        case 2 : 
+          {
+            y |= ((((x>>( 8+offset))&0xff) << ( 0+offset)) |
+                  (((x>>( 0+offset))&0xff) << ( 8+offset)) );
+            break;
+          }
+        case 4 : 
+          {
+            y |= ((((x>>(24+offset))&0xff) << ( 0+offset)) |
+                  (((x>>(16+offset))&0xff) << ( 8+offset)) |
+                  (((x>>( 8+offset))&0xff) << (16+offset)) |
+                  (((x>>( 0+offset))&0xff) << (24+offset)) );
+            break;
+          }
+        case 8 : 
+          {
+            y |= ((((x>>(56+offset))&0xff) << ( 0+offset)) |
+                  (((x>>(48+offset))&0xff) << ( 8+offset)) |
+                  (((x>>(40+offset))&0xff) << (16+offset)) |
+                  (((x>>(32+offset))&0xff) << (24+offset)) |
+                  (((x>>(24+offset))&0xff) << (32+offset)) |
+                  (((x>>(16+offset))&0xff) << (40+offset)) |
+                  (((x>>( 8+offset))&0xff) << (48+offset)) |
+                  (((x>>( 0+offset))&0xff) << (56+offset)) );
+            break;
+          }
+        default :
+            {
+              break;
+            }
+        }
+    }
+
+  return static_cast<T>(y);
+}
+
+template <typename T>
+T swapBits (T data, uint32_t size_data, uint32_t size_access)
+{
+  uint8_t x = static_cast<uint8_t>(data);
+
+  uint8_t y=0;
+
+  for (uint32_t i=0; i<size_data; i+=size_access)
+    {
+      uint32_t offset = i;
+
+      switch (size_access)
+        {
+        case 1 :
+          {
+            y = x;
+            break;
+          }
+        case 2 : 
+          {
+            y |= ((((x>>( 1+offset))&0x1) << ( 0+offset)) |
+                  (((x>>( 0+offset))&0x1) << ( 1+offset)) );
+            break;
+          }
+        case 4 : 
+          {
+            y |= ((((x>>( 3+offset))&0x1) << ( 0+offset)) |
+                  (((x>>( 2+offset))&0x1) << ( 1+offset)) |
+                  (((x>>( 1+offset))&0x1) << ( 2+offset)) |
+                  (((x>>( 0+offset))&0x1) << ( 3+offset)) );
+            break;
+          }
+        case 8 : 
+          {
+            y |= ((((x>>( 7+offset))&0x1) << ( 0+offset)) |
+                  (((x>>( 6+offset))&0x1) << ( 1+offset)) |
+                  (((x>>( 5+offset))&0x1) << ( 2+offset)) |
+                  (((x>>( 4+offset))&0x1) << ( 3+offset)) |
+                  (((x>>( 3+offset))&0x1) << ( 4+offset)) |
+                  (((x>>( 2+offset))&0x1) << ( 5+offset)) |
+                  (((x>>( 1+offset))&0x1) << ( 6+offset)) |
+                  (((x>>( 0+offset))&0x1) << ( 7+offset)) );
+            break;
+          }
+        default :
+            {
+              break;
+            }
+        }
+    }
+
+  return static_cast<T>(y);
+}
 
 #undef  FUNCTION
@@ -83,4 +290,6 @@
 
 		log_printf(TRACE,Load_store_unit,FUNCTION,"    * index_store : %d",index_store);
+		log_printf(TRACE,Load_store_unit,FUNCTION,"    * ptr_read    : %d",reg_STORE_QUEUE_PTR_READ);
+
 		if (index_store == reg_STORE_QUEUE_PTR_READ)
 		  {
@@ -148,9 +357,34 @@
 				  
                                   // Read data
-				  Tgeneral_data_t load_data  = _load_queue [index_load ]._rdata  ;
-				  Tgeneral_data_t store_data = _store_queue[index_store]._wdata  ;
-				  
-				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * load_data  (before): 0x%.8x",load_data);
-				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * store_data (before): 0x%.8x",store_data);
+                                  bool is_big_endian = true;
+
+				  Tgeneral_data_t   load_data      = _load_queue [index_load ]._rdata  ;
+				  Tgeneral_data_t   store_data     = _store_queue[index_store]._wdata  ;
+                                  Tdcache_address_t check_hit_byte = _load_queue [index_load ]._check_hit_byte;
+                                  Tcontrol_t        check_hit      = _load_queue [index_load ]._check_hit;
+                                  uint32_t          load_size_access  = memory_size(_load_queue [index_load ]._operation)>>3;
+                                  uint32_t          store_size_access = memory_size(_store_queue[index_store]._operation)>>3;
+
+                                  log_printf(TRACE,Load_store_unit,FUNCTION,"            * is_big_endian           : %d",is_big_endian);
+                                  log_printf(TRACE,Load_store_unit,FUNCTION,"            * load_data               : 0x%.8x",load_data);
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * store_data              : 0x%.8x",store_data);
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit_byte          : %x",check_hit_byte);
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit               : %d",check_hit);
+
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * load_size_access        : %d",load_size_access );
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * store_size_access       : %d",store_size_access);
+
+                                  if (is_big_endian)
+                                    {
+                                      // swap in little endian
+                                      load_data      = swapBytes<Tgeneral_data_t  >(load_data     , _param->_size_general_data>>3,load_size_access);
+                                      store_data     = swapBytes<Tgeneral_data_t  >(store_data    , _param->_size_general_data>>3,store_size_access);
+                                      check_hit_byte = swapBits <Tdcache_address_t>(check_hit_byte, _param->_size_general_data>>3,load_size_access);
+                                      
+                                      
+                                      log_printf(TRACE,Load_store_unit,FUNCTION,"            * load_data      (swap 1) : 0x%.8x",load_data);
+                                      log_printf(TRACE,Load_store_unit,FUNCTION,"            * store_data     (swap 1) : 0x%.8x",store_data);
+                                      log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit_byte (swap 1) : %x",check_hit_byte);
+                                    }
 
                                   uint32_t store_nb_byte     = (1<<memory_access(_store_queue[index_store]._operation));
@@ -160,76 +394,85 @@
 				  uint32_t store_num_byte_max = store_num_byte_min+store_nb_byte;
 
-				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * store_num_byte_min : %d",store_num_byte_min);
-				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * store_num_byte_max : %d",store_num_byte_max);
-				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit          : %x",_load_queue[index_load]._check_hit);
-				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit_byte     : %x",_load_queue[index_load]._check_hit_byte);
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * store_num_byte_min      : %d",store_num_byte_min);
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * store_num_byte_max      : %d",store_num_byte_max);
+
+//                                   uint32_t load_nb_byte      = (1<<memory_access(_load_queue[index_load]._operation));
+
+// 				  uint32_t load_num_byte_min = (load_addr & _param->_mask_address_lsb);
+// 				  uint32_t load_num_byte_max = load_num_byte_min+load_nb_byte;
+
+// 				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * load_num_byte_min       : %d",load_num_byte_min);
+// 				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * load_num_byte_max       : %d",load_num_byte_max);
+
+// 				  for (uint32_t num_load_byte=load_num_byte_min; num_load_byte<load_num_byte_max; num_load_byte ++)
+// 				    {
+//                                       // Make a mask
+//                                       uint32_t num_store_byte = num_load_byte;
+                                      
+
+
 				  // The bypass is checked byte per byte
                                   // Is same endianness : because to change endianness, we must write in special register. Also the pipeline is flushed.
-                                  bool is_big_endian = true;
-
 				  for (uint32_t num_store_byte=store_num_byte_min; num_store_byte<store_num_byte_max; num_store_byte ++)
 				    {
                                       // Make a mask
-                                      uint32_t num_load_byte;
-
-                                      if (is_big_endian)
-                                        {
-                                          // sd 0 : 0 1 2 3 4 5 6 7
-                                          // ld 0 : 0 1 2 3 4 5 6 7 >>  0 
-                                          // lw 0 :         0 1 2 3 >>  0 -4
-                                          // lw 4 : 4 5 6 7         >> 32 +4
-                                          // lh 0 :             0 1 >>  0 -6
-                                          // lh 2 :         2 3     >> 16 -2
-                                          // lh 4 :     4 5         >> 32 +2
-                                          // lh 6 : 6 7             >> 48 +6
-                                          // lb 0 :               0 >>  0 -7
-                                          // lb 1 :             1   >>  8 -5
-                                          // lb 2 :           2     >> 16 -3
-                                          // lb 3 :         3       >> 24 -1
-                                          // lb 4 :       4         >> 32 +1
-                                          // lb 5 :     5           >> 40 +3
-                                          // lb 6 :   6             >> 48 +5
-                                          // lb 7 : 7               >> 56 +7
-
-                                          // diff : (store_nb_byte + load_nb_byte) - 2*nb_load_byte*((num_store_byte+1)
-
-                                          // store duplicate = all store access can be see as full size_data store
-                                          uint32_t load_nb_byte = (1<<memory_access(_load_queue [index_load ]._operation));
-
-//                                           log_printf(TRACE,Load_store_unit,FUNCTION,"                * num_store_byte       : %d",num_store_byte);
-//                                           log_printf(TRACE,Load_store_unit,FUNCTION,"                * size_general_data>>3 : %d",(_param->_size_general_data>>3));
-//                                           log_printf(TRACE,Load_store_unit,FUNCTION,"                * load_nb_byte         : %d",load_nb_byte);
-//                                           log_printf(TRACE,Load_store_unit,FUNCTION,"                * x = ((_param->_size_general_data>>3)+load_nb_byte-2*load_nb_byte*(num_store_byte/load_nb_byte+1)) = %d+%d-%d*%d = %d"
-//                                                      , (_param->_size_general_data>>3)
-//                                                      , load_nb_byte
-//                                                      , 2*load_nb_byte
-//                                                      ,((num_store_byte/load_nb_byte)+1)
-//                                                      ,((_param->_size_general_data>>3)+load_nb_byte-2*load_nb_byte*((num_store_byte/load_nb_byte)+1)));
+                                      uint32_t num_load_byte = num_store_byte;
+
+//                                       if (is_big_endian)
+//                                         {
+//                                           // sd 0 : 0 1 2 3 4 5 6 7
+//                                           // ld 0 : 0 1 2 3 4 5 6 7 >>  0 
+//                                           // lw 0 :         0 1 2 3 >>  0 -4
+//                                           // lw 4 : 4 5 6 7         >> 32 +4
+//                                           // lh 0 :             0 1 >>  0 -6
+//                                           // lh 2 :         2 3     >> 16 -2
+//                                           // lh 4 :     4 5         >> 32 +2
+//                                           // lh 6 : 6 7             >> 48 +6
+//                                           // lb 0 :               0 >>  0 -7
+//                                           // lb 1 :             1   >>  8 -5
+//                                           // lb 2 :           2     >> 16 -3
+//                                           // lb 3 :         3       >> 24 -1
+//                                           // lb 4 :       4         >> 32 +1
+//                                           // lb 5 :     5           >> 40 +3
+//                                           // lb 6 :   6             >> 48 +5
+//                                           // lb 7 : 7               >> 56 +7
+
+//                                           // diff : (store_nb_byte + load_nb_byte) - 2*nb_load_byte*((num_store_byte+1)
+
+//                                           // store duplicate = all store access can be see as full size_data store
+// //                                           uint32_t load_nb_byte = (1<<memory_access(_load_queue [index_load ]._operation));
+
+// //                                           int32_t diff = ((_param->_size_general_data>>3)+load_nb_byte-2*load_nb_byte*((num_store_byte/load_nb_byte)+1));
+
+// //                                           num_load_byte =num_store_byte+diff;
+
+// //                                           log_printf(TRACE,Load_store_unit,FUNCTION,"              * load_nb_byte   : %d",load_nb_byte);
+// //                                           log_printf(TRACE,Load_store_unit,FUNCTION,"              * diff           : %d",diff);
+
+
+//                                           num_load_byte = num_store_byte;
+//                                         }
+//                                       else
+//                                         {
+//                                           // sd 0 : 0 1 2 3 4 5 6 7
+//                                           // ld 0 : 0 1 2 3 4 5 6 7 >>  0
+//                                           // lw 0 :         4 5 6 7 >>  0
+//                                           // lw 4 : 0 1 2 3         >> 32
+//                                           // lh 0 :             6 7 >>  0
+//                                           // lh 2 :         4 5     >> 16
+//                                           // lh 4 :     2 3         >> 32
+//                                           // lh 6 : 0 1             >> 48
+//                                           // lb 0 :               7 >>  0
+//                                           // lb 1 :             6   >>  8
+//                                           // lb 2 :           5     >> 16
+//                                           // lb 3 :         4       >> 24
+//                                           // lb 4 :       3         >> 32
+//                                           // lb 5 :     2           >> 40
+//                                           // lb 6 :   1             >> 48
+//                                           // lb 7 : 0               >> 56
                                           
-
-                                          num_load_byte =num_store_byte+((_param->_size_general_data>>3)+load_nb_byte-2*load_nb_byte*((num_store_byte/load_nb_byte)+1));
-                                        }
-                                      else
-                                        {
-                                          // sd 0 : 0 1 2 3 4 5 6 7
-                                          // ld 0 : 0 1 2 3 4 5 6 7 >>  0
-                                          // lw 0 :         4 5 6 7 >>  0
-                                          // lw 4 : 0 1 2 3         >> 32
-                                          // lh 0 :             6 7 >>  0
-                                          // lh 2 :         4 5     >> 16
-                                          // lh 4 :     2 3         >> 32
-                                          // lh 6 : 0 1             >> 48
-                                          // lb 0 :               7 >>  0
-                                          // lb 1 :             6   >>  8
-                                          // lb 2 :           5     >> 16
-                                          // lb 3 :         4       >> 24
-                                          // lb 4 :       3         >> 32
-                                          // lb 5 :     2           >> 40
-                                          // lb 6 :   1             >> 48
-                                          // lb 7 : 0               >> 56
-                                          
-                                          num_load_byte = num_store_byte;
-                                        }
-                                      
+//                                           num_load_byte = num_store_byte;
+//                                         }
+
 				      uint32_t mask  = 1<<num_load_byte;
 
@@ -241,10 +484,10 @@
                                       //   * they have not a previous bypass with an another store
                                       //   * it's a valid request of load
-				      if ((_load_queue[index_load]._check_hit_byte&mask)==0)
+				      if ((check_hit_byte&mask)==0)
 					{
                                           // Note : Store is duplicate = all store access can be see as full size_data store
 
                                           uint32_t num_store_bit_min = num_store_byte<<3; //*8
-//                                         uint32_t num_store_bit_max = num_store_bit_min+8-1;
+//                                        uint32_t num_store_bit_max = num_store_bit_min+8-1;
                                           uint32_t num_load_bit_min  = num_load_byte <<3; //*8
                                           uint32_t num_load_bit_max  = num_load_bit_min+8-1;
@@ -259,6 +502,6 @@
                                                        mask_not<Tdcache_data_t>(load_data,num_load_bit_max,num_load_bit_min));
 
-					  _load_queue[index_load]._check_hit_byte |= mask;
-					  _load_queue[index_load]._check_hit       = 1;
+					  check_hit_byte |= mask;
+					  check_hit       = 1;
 					  change_state = true;
 
@@ -267,9 +510,23 @@
 				    }
 
-				  _load_queue[index_load]._rdata = load_data;
+                                  if (is_big_endian)
+                                    {
+                                      // swap in little endian
+                                      load_data      = swapBytes<Tgeneral_data_t  >(load_data     , _param->_size_general_data>>3,load_size_access);
+                                      check_hit_byte = swapBits <Tdcache_address_t>(check_hit_byte, _param->_size_general_data>>3,load_size_access);
+                                      
+                                      
+                                      log_printf(TRACE,Load_store_unit,FUNCTION,"            * load_data      (swap 2) : 0x%.8x",load_data);
+                                      log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit_byte (swap 2) : %x",check_hit_byte);
+                                    }
+
+				  _load_queue[index_load]._rdata          = load_data;
+                                  _load_queue[index_load]._check_hit_byte = check_hit_byte;
+                                  _load_queue[index_load]._check_hit      = check_hit;
+
 				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * load_data  (after) : 0x%.8x",load_data);
 
-				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit          : %x",_load_queue[index_load]._check_hit);
-				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit_byte     : %x",_load_queue[index_load]._check_hit_byte);
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit          : %x",check_hit);
+				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * check_hit_byte     : %x",check_hit_byte);
 
 				  log_printf(TRACE,Load_store_unit,FUNCTION,"            * mask_end_check     : %x",(-1& _param->_mask_address_lsb));
@@ -295,4 +552,5 @@
 		  {
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"              * next");
+		    log_printf(TRACE,Load_store_unit,FUNCTION,"                * new store_queue_ptr_write : %d",index_store);
 // 		    if (_load_queue[index_load]._store_queue_ptr_write == 0)
 // 		      _load_queue[index_load]._store_queue_ptr_write = _param->_size_store_queue-1;
@@ -312,8 +570,16 @@
 		  {
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"              * change_state");
+                    log_printf(TRACE,Load_store_unit,FUNCTION,"              * end_check : %d",end_check);
+
+		    log_printf(TRACE,Load_store_unit,FUNCTION,"                * state old : %s",toString(_load_queue[index_load]._state).c_str());
 
 		    switch (_load_queue[index_load]._state)
 		      {
-		      case LOAD_QUEUE_WAIT_CHECK   : _load_queue[index_load]._state = LOAD_QUEUE_WAIT  ; break;
+		      case LOAD_QUEUE_WAIT_CHECK   : 
+                        {
+			  if (end_check)
+                            _load_queue[index_load]._state = LOAD_QUEUE_WAIT  ; 
+                          break;
+                        }
 		      case LOAD_QUEUE_COMMIT_CHECK : 
 			{
@@ -321,5 +587,5 @@
 			    _load_queue[index_load]._state = LOAD_QUEUE_COMMIT; 
 			  else
-			    _load_queue[index_load]._state = LOAD_QUEUE_CHECK;
+			    _load_queue[index_load]._state = LOAD_QUEUE_CHECK; // No commit : check hit and no end
 			  break;
 			}
@@ -328,6 +594,9 @@
 			  if (end_check)
 			    _load_queue[index_load]._state     = LOAD_QUEUE_COMMIT;
+
 			  // check find a bypass. A speculative load have been committed : report a speculation miss.
-			  if (_load_queue[index_load]._check_hit != 0)
+			  if ((_load_queue[index_load]._check_hit != 0)//  and 
+//                               (_load_queue[index_load]._write_rd  == 0)
+                              )
 			    {
 			      _load_queue[index_load]._exception = EXCEPTION_MEMORY_MISS_SPECULATION;
@@ -339,5 +608,5 @@
 		      default : break;
 		      }
-		    log_printf(TRACE,Load_store_unit,FUNCTION,"                * new state : %d",_load_queue[index_load]._state);
+		    log_printf(TRACE,Load_store_unit,FUNCTION,"                * state new : %s",toString(_load_queue[index_load]._state).c_str());
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"                * exception : %d",_load_queue[index_load]._exception);
 		  }
@@ -712,4 +981,5 @@
 
 	    log_printf(TRACE,Load_store_unit,FUNCTION,"    * original packet_id : %d"  , packet_id);
+	    log_printf(TRACE,Load_store_unit,FUNCTION,"    * packet_id          : %d"  , packet_id>>1);
 	    log_printf(TRACE,Load_store_unit,FUNCTION,"    * rdata              : %.8x", rdata);
 	    log_printf(TRACE,Load_store_unit,FUNCTION,"    * error              : %d"  , error);
@@ -719,7 +989,6 @@
 		packet_id >>= 1;
 
-		log_printf(TRACE,Load_store_unit,FUNCTION,"    * packet is a LOAD  : %d", packet_id);
+		log_printf(TRACE,Load_store_unit,FUNCTION,"    * packet is a LOAD");
  
-
 #ifdef DEBUG_TEST
 		if (not have_dcache_rsp(_load_queue [packet_id]._operation))
@@ -754,5 +1023,5 @@
 		  {
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"    * have no bus error.");
-		    log_printf(TRACE,Load_store_unit,FUNCTION,"      * previous state : %d.",_load_queue [packet_id]._state);
+		    log_printf(TRACE,Load_store_unit,FUNCTION,"      * previous state : %s",toString(_load_queue [packet_id]._state).c_str());
 
 		    // FIXME : convention : if bus error, the cache return the fautive address !